#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct AssetStreamConfiguration {
    #[builder(
        default,
        list(
            item(
                type = super::super::super::integrations::api::NotificationConfiguration
            )
        )
    )]
    #[serde(
        rename = "notificationConfigurations",
        skip_serializing_if = "Vec::is_empty",
        default
    )]
    notification_configurations: Vec<
        super::super::super::integrations::api::NotificationConfiguration,
    >,
    #[builder(
        custom(type = super::super::super::run::api::Duration, convert = Box::new)
    )]
    #[serde(rename = "evaluationDelay")]
    evaluation_delay: Box<super::super::super::run::api::Duration>,
    #[builder(
        custom(type = super::super::super::run::api::Duration, convert = Box::new)
    )]
    #[serde(rename = "recoveryDelay")]
    recovery_delay: Box<super::super::super::run::api::Duration>,
    #[serde(rename = "autoCreateEvents")]
    auto_create_events: bool,
}
impl AssetStreamConfiguration {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        evaluation_delay: super::super::super::run::api::Duration,
        recovery_delay: super::super::super::run::api::Duration,
        auto_create_events: bool,
    ) -> Self {
        Self::builder()
            .evaluation_delay(evaluation_delay)
            .recovery_delay(recovery_delay)
            .auto_create_events(auto_create_events)
            .build()
    }
    #[inline]
    pub fn notification_configurations(
        &self,
    ) -> &[super::super::super::integrations::api::NotificationConfiguration] {
        &*self.notification_configurations
    }
    #[inline]
    pub fn evaluation_delay(&self) -> &super::super::super::run::api::Duration {
        &*self.evaluation_delay
    }
    #[inline]
    pub fn recovery_delay(&self) -> &super::super::super::run::api::Duration {
        &*self.recovery_delay
    }
    #[inline]
    pub fn auto_create_events(&self) -> bool {
        self.auto_create_events
    }
}
